import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface CustomFieldSchemaFieldConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#default_value CustomFieldSchemaFieldConfiguration#default_value}
    */
    readonly defaultValue?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#default_value_datatype CustomFieldSchemaFieldConfiguration#default_value_datatype}
    */
    readonly defaultValueDatatype?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#default_value_multi_value CustomFieldSchemaFieldConfiguration#default_value_multi_value}
    */
    readonly defaultValueMultiValue?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#field CustomFieldSchemaFieldConfiguration#field}
    */
    readonly field: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#id CustomFieldSchemaFieldConfiguration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#required CustomFieldSchemaFieldConfiguration#required}
    */
    readonly required?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration#schema CustomFieldSchemaFieldConfiguration#schema}
    */
    readonly schema: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration pagerduty_custom_field_schema_field_configuration}
*/
export declare class CustomFieldSchemaFieldConfiguration extends cdktf.TerraformResource {
    static readonly tfResourceType = "pagerduty_custom_field_schema_field_configuration";
    /**
    * Create a new {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/resources/custom_field_schema_field_configuration pagerduty_custom_field_schema_field_configuration} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options CustomFieldSchemaFieldConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: CustomFieldSchemaFieldConfigurationConfig);
    private _defaultValue?;
    get defaultValue(): string;
    set defaultValue(value: string);
    resetDefaultValue(): void;
    get defaultValueInput(): string | undefined;
    private _defaultValueDatatype?;
    get defaultValueDatatype(): string;
    set defaultValueDatatype(value: string);
    resetDefaultValueDatatype(): void;
    get defaultValueDatatypeInput(): string | undefined;
    private _defaultValueMultiValue?;
    get defaultValueMultiValue(): boolean | cdktf.IResolvable;
    set defaultValueMultiValue(value: boolean | cdktf.IResolvable);
    resetDefaultValueMultiValue(): void;
    get defaultValueMultiValueInput(): boolean | cdktf.IResolvable | undefined;
    private _field?;
    get field(): string;
    set field(value: string);
    get fieldInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _required?;
    get required(): boolean | cdktf.IResolvable;
    set required(value: boolean | cdktf.IResolvable);
    resetRequired(): void;
    get requiredInput(): boolean | cdktf.IResolvable | undefined;
    private _schema?;
    get schema(): string;
    set schema(value: string);
    get schemaInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
