import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/data-sources/user#email DataPagerdutyUser#email}
    */
    readonly email: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/data-sources/user#id DataPagerdutyUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/data-sources/user pagerduty_user}
*/
export declare class DataPagerdutyUser extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "pagerduty_user";
    /**
    * Create a new {@link https://registry.terraform.io/providers/pagerduty/pagerduty/2.14.6/docs/data-sources/user pagerduty_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyUserConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyUserConfig);
    private _email?;
    get email(): string;
    set email(value: string);
    get emailInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get name(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
